#GTCMOS --- Package for IRAF routines to reduce GTC OSIRIS/MOS data

# Load necessary packages - only those that are used by all packages
imred
generic
twodspec
longslit
apextract
onedspec
longslit.dispaxis=2
onedspec.dispaxis=2
;
cl < "gtcmos$lib/zzsetenv.def"
package gtcmos

task om_x_curve   = "gtcmossrc$om_x_curve.cl"
task omspestat    = "gtcmossrc$omspestat.cl"
task osiris_lam_calib = "gtcmossrc$osiris_lam_calib.cl"
task omlam_to_pix = "gtcmossrc$omlam_to_pix.cl"
task omskyplot    = "gtcmossrc$omskyplot.cl"
task goghost      = "gtcmossrc$goghost.cl"
task omstd        = "gtcmossrc$omstd.cl"
task omfindstd    = "gtcmossrc$omfindstd.cl"
task omflat       = "gtcmossrc$omflat.cl"
task omextract    = "gtcmossrc$omextract.cl"
task omslice      = "gtcmossrc$omslice.cl"
task omunlearn    = "gtcmossrc$omunlearn.cl"
task olreduce     = "gtcmossrc$olreduce.cl"
task oltilt       = "gtcmossrc$oltilt.cl"
task omcombine    = "gtcmossrc$omcombine.cl"
task $omfitfunc   = "gtcmossrc$omfitfunc.cl"
task omfitfuns    = "gtcmossrc$omfitfuns.cl"
task omidentify   = "gtcmossrc$omidentify.cl"
task omlinefit    = "gtcmossrc$omlinefit.cl"
task omreduce     = "gtcmossrc$omreduce.cl"
task omskysub     = "gtcmossrc$omskysub.cl"
task omreidentify = "gtcmossrc$omreidentify.cl"
task omslits      = "gtcmossrc$omslits.cl"
task omstart      = "gtcmossrc$omstart.cl"
task omlongslit   = "gtcmossrc$omlongslit.cl"
task omwcal_coef  = "gtcmossrc$omwcal_coef.cl"
task omwcal_lines = "gtcmossrc$omwcal_lines.cl"
task omsky1d      = "gtcmossrc$omsky1d.cl"
task om2dsky      = "gtcmossrc$om2dsky.cl"
task ommake2d     = "gtcmossrc$ommake2d.cl"
task omnormalize  = "gtcmossrc$omnormalize.cl"
task mosaic_1x1_v2= "gtcmossrc$mosaic_1x1_v2.cl"
task mosaic_2x1_v2= "gtcmossrc$mosaic_2x1_v2.cl"
task mosaic_2x2_v2= "gtcmossrc$mosaic_2x2_v2.cl"

hide oltilt
hide olreduce
hide omlongslit
hide mosaic_1x1_v2
hide mosaic_2x1_v2
hide mosaic_2x2_v2
hide omfitfunc
hide omfitfuns
hide omlinefit
hide ommake2d
hide omnormalize
hide omsky1d
hide om2dsky
hide omwcal_coef
hide omwcal_lines
hide omskyplot
hide omlam_to_pix
hide om_x_curve
hide omspestat
hide osiris_lam_calib
hide goghost

#task = "gtcmossrc$.cl"

print(" ")
print("     +------------------- GTCMOS IRAF Package -------------------+")
print("     |             Version 1.5, Jan 10, 2018                     |")
print("     |            Tested with IRAF v2.16 on Fedora               |")
print("     |    Developed by Divakara Mayya at INAOE, Puebla, Mexico   |")
print("     |                                                           |")
print("     |    Type  help  before using it for the first time         |")
print("     |                                                           |")
print("     | User's guide is available at                              |")
print("     |   file:///iraf/iraf/extern/gtcmos/html/mos_reduction.html |")
print("     |                                                           |")
print("     |Please contact ydm@inaoep.mx if you have questions/comments|")
print("     +-----------------------------------------------------------+")
print(" ")
;
clbye()

