procedure omreduce(filnam, filarc)

string  filnam    = "gtc14a_mos1abc" {prompt="File Name"}
string  filarc    = "std"            {prompt="Comparison arc file [std|auto|arcfile]"}
#string  filarc    = "auto"          {prompt="Comparison arc file [auto|gtc14a_p1arc_m_HgArNe]"}
string  filflat   = ""      	     {prompt="Master Flat file [gtc14a_p1_m_flat_b or empty]"}
string  senscur   = ""   	     {prompt="Sensitivity curve imagename"}
real	dlam      =  INDEF           {prompt="Wavelength interval in Ang/pixel"}
real	pixref    =  INDEF           {prompt="Pixel at which lambda=lamref [INDEF=middle]"}
real	lamref    =  INDEF           {prompt="Lambda in Ang at pixref"}
bool    tilt_slit = no   	     {prompt="Correct for Slit tilt?"} 
bool    fiducial  = no   	     {prompt="Retain fiducial stars?"} 
bool    checksky  = no   	     {prompt="Improve lambda calibration by checking a skyline?"} 
real	lamsky    = 5577.838         {prompt="Lambda of a sky line in Ang"}
string  slitrej   = ""        	     {prompt="Slitlet numbers to reject"}
int	cleanlev  = 2		     {prompt="Clean Level [2=del all intermediate fits] [0=retain all]"}

#input datafiles: ds9_head.txt, database/idarcoR1000B, MOS_lambda_calib.dat, identify_template

begin
	string filin, cutc46, sn, stype, sec[999], comm1, filetra, filelam, secj
	string	splotfillog, grism, fillamp, flatim, statsec[999]
	string	flattra, flatlam, slitreject, omflat, sensfun
	real	slitx, slity, slitw, slitl, slito, slitr, xbin, ybin, slityx, dyxj
	real	lamc, lam1, lam2, y5577, slity0, dyx, slityx_5577
	real	aa, bb, cc, ee, ff, dlam0
	real	slityxc, ce[4], lamref_corr
	real	slitlam_sky, slitlam0_sky, pixcen, lamcen, dw, dlam1, lamini
	real	flatnor, flat[999], ydist, ydistmin
	int	i1, nslits, ix1, ix2, islit, islitx, iref, slitxref, clevel, npix, nrej, irej
	bool	slit_orient, doflat, dosens, show_circular, fitlin, fitslit[999]
        real   center, cont, flux, eqw, core, gfwhm, lfwhm

        filin = filnam; fillamp = filarc; slitlam_sky = lamsky 
	flatim = filflat; doflat = yes; if (flatim == "") {doflat = no}
	sensfun = senscur; dosens = yes; if (sensfun == "") {dosens = no}
	show_circular = fiducial; slit_orient = tilt_slit
	dlam1 = dlam; pixcen = pixref; lamcen = lamref; slitreject = slitrej

	omflat = " "
        if (doflat && imaccess(flatim)) {hselect (flatim, "OMFLAT", expr+) | scan (omflat) }
	if (doflat && omflat == " ") {print("*** Run omflat ",flatim); goto goexit}
	#print(omflat)

	if (dosens && !imaccess(sensfun)) 
	        {print("*** Sensitivity curve not found. Run omstd "); goto goexit}

        hselect (filin, "GRISM NAXIS2", expr+) | scan (grism, npix)
        match (grism, "gtcinputs$MOS_lambda_calib.dat") | fields (fields="4-9") | scan (dlam0,aa,bb,cc,ee,ff)
	if (dlam1 == INDEF) {dlam1 = dlam0}
	if (pixcen == INDEF) {pixcen = real(npix/2 + 1)}
        if (lamcen == INDEF) {lamcen = aa + bb*pixcen + cc*pixcen**2}
	lamini = max(3000., lamcen - (pixcen - 1.0)*dlam1)
        slity0 = (slitlam_sky - lamini)/dlam1 + 1.0

	fitlin = checksky
	clevel = cleanlev  
	filetra = filin//"_wl"; filelam = filin//"_t"
	if (doflat) {filetra = filetra//"_flt"}
	if (slit_orient) {filetra = filetra//"_tlt"}
	imdelete (filetra, ver-, >& "dev$null"); imdelete (filelam, ver-, >& "dev$null")
	delete ("splot_auto_gaussfit_parameters.log", ver-, >& "dev$null")
	if (!access("database")) {mkdir "database"}

	if (doflat) {
		flattra = flatim//"_wl"; flatlam = flatim//"_t"
		imdelete (flattra, ver-, >& "dev$null"); imdelete (flatlam, ver-, >& "dev$null")
		delete (flatim//"_av.log", ver-, >& "dev$null")
        	imarith (flatim, "*", 0.0, flattra, ver-)
        	imarith (flatim, "*", 0.0, flatlam, ver-)
		#imdelete (flatim//"_wl", ver-, >& "dev$null") #imarith (flatim, "*", 0.0, flatim//"_wl", ver-)
	}
        imarith (filin, "*", 0.0, filetra, ver-)
        imarith (filin, "*", 0.0, filelam, ver-)

        omslits (filin, verb-)
        nslits = omslits.nslitlets
        list = omslits.out

	#nslits = 3
	if (nslits <= 1) {
	print ("*** Error: No slits found ***")
	} else {

	iref = 1; ydistmin = 500.
        i1 = 0
        for (i = 1; i <= nslits; i = i + 1) {
        i1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype, slito)
        sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"
	ydist = abs(slity-995.0)
	if (ydist < ydistmin && stype != "circular") {ydistmin = ydist; iref = i; slitxref = slitx}
	fitslit[i] = yes
	}
	print ("Reference Slitlet: i=", iref, "x=", slitxref, "ydist=",ydistmin)
	files(slitreject) | wc | scan(nrej)
	for (i = 1; i <= nrej; i = i + 1) {
	files(slitreject) | fields (fields=1, lines=i) | scan(irej)
	fitslit[irej] = no
	print("Slit no ", i, " for rejection = ", irej)
	}

        list = omslits.out
        i1 = 0
        for (i = 1; i <= nslits; i = i + 1) {
        i1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype, slito)

	#_________________________________________________________________________
	#Block_3 - Wavelength Calibrate each slitlet either by previously identified arclamp
	#          solutions or automatically using an emperical equation for the dispersion.
	#          In either case dispersion is fixed at the value of slitlet 1 (or slitrefi - not implemented)
	#_________________________________________________________________________

	imdelete (filin//"_"//str(i), ver-, >& "dev$null")
	imdelete (filin//"_"//str(i)//"_wl", ver-, >& "dev$null")
	imcopy (filin//sec[i], filin//"_"//str(i), ver-)

        if (stype == "rectangular" && slit_orient && !fitlin) {
	imdelete (filin//"_"//str(i), ver-, >& "dev$null")
        for (j = ix1; j <= ix2; j = j + 2) {
        imdelete (filin//"_tmp", ver-, >& "dev$null")
        secj = "["//str(j)//":"//str(j+1)//",*]"
        slityxc = slity0 + (real(j) - slitx)*tan(slito*PI/180.)
        imlintran (filin//secj, filin//"_tmp", xrot=0., yrot=0.0, xmag=1.0, ymag=1.0, yin=slityxc, yout=slity0, boundar="constant", constant=0.0, ver-)
        imcopy (filin//"_tmp", filelam//secj, ver-)
	}
	imcopy (filelam//sec[i], filin//"_"//str(i), ver-)
	}

	if (fillamp == "auto") {
	  delete ("database/id"//filin//"_arc_emp", ver-, >& "dev$null")
	  hedit (filin//"_"//str(i), "REFSPEC1", filin//"_arc_emp", add+, ver-, show-)
          omwcal_coef (slity, order=1, grating=grism) | scan (ce[4], ce[3], ce[2], ce[1])
          #print (ce[1], ce[2], ce[3], ce[4])
          copy ("gtcinputs$identify_template", "database/id"//filin//"_arc_emp", verb-)
          print (ce[1], >> "database/id"//filin//"_arc_emp")
          print (ce[2], >> "database/id"//filin//"_arc_emp")
          print (ce[3], >> "database/id"//filin//"_arc_emp")
          print (ce[4], >> "database/id"//filin//"_arc_emp")
	  } else if (fillamp == "std") { 
	  delete ("database/id"//filin, ver-, >& "dev$null")
          imdelete (filin//"_tmp", ver-, >& "dev$null")
	  imlintran (filin//"_"//str(i), filin//"_tmp", xrot=0., yrot=0.0, xmag=1.0, ymag=1.0, yin=slityx, yout=slity, boundar="constant", constant=0.0, ver-)
          imdelete (filin//"_"//str(i), ver-, >& "dev$null")
	  imrename (filin//"_tmp", filin//"_"//str(i), ver-)
	  hedit (filin//"_"//str(i), "REFSPEC1", filin, add+, ver-, show-)
          copy ("gtcinputs$idarco"//grism//".txt", "database/id"//filin, verb-)
	  } else {
	  hedit (filin//"_"//str(i), "REFSPEC1", fillamp//"_"//str(i), add+, ver-, show-)
	  }
		dispcor (filin//"_"//str(i), filin//"_"//str(i)//"_wl", w1=lamini, dw=dlam1, nw=npix, verb-)
	hselect (filin//"_"//str(i)//"_wl", "CRPIX2 CRVAL2 CDELT2", expr+) | scan(pixcen, lamcen, dw)
	#print (pixref, lamref, dlam)

	#_________________________________________________________________________
	#Block_4 - If asked, normalize the flats at lam=slitlam_sky of slitref (=slilet 1) and
	#          divide each slitlet spectrum by the normalized flat
	#_________________________________________________________________________
        imdelete (flatim//"_"//str(i), ver-, >& "dev$null")
        imdelete (flatim//"_"//str(i)//"_wl", ver-, >& "dev$null")

	if (doflat) {
	  imcopy (flatim//sec[i], flatim//"_"//str(i), ver-)
          #imarith (filin//"_"//str(i), "/", flatim//"_"//str(i), filin//"_temp_"//str(i), verb-)
	if (fillamp == "auto") {
	  hedit (flatim//"_"//str(i), "REFSPEC1", filin//"_arc_emp", add+, ver-, show-)
	  } else if (fillamp == "std") { 
          imdelete (filin//"_temp_"//str(i), ver-, >& "dev$null")
          imdelete (filin//"_temp_"//str(i)//"_wl", ver-, >& "dev$null")
	  imarith (filin//"_"//str(i), "/", flatim//"_"//str(i), filin//"_temp_"//str(i), verb-)
	  dispcor (filin//"_temp_"//str(i), filin//"_temp_"//str(i)//"_wl", w1=lamini, dw=dlam1, nw=npix, verb-)
	  slityxc = (slitlam_sky - lamcen)/dw + pixcen
		} else {
	  hedit (flatim//"_"//str(i), "REFSPEC1", fillamp//"_"//str(i), add+, ver-, show-)
		}
	if (fillamp != "std") {
	#} else {	
	  dispcor (flatim//"_"//str(i), flatim//"_"//str(i)//"_wl", dw=dlam1, nw=npix, verb-)
	slityxc = (slitlam_sky - lamcen)/dw + pixcen
	  statsec[i] = "["//str(ix1)//":"//str(ix2)//","//str(int(slityxc-10.0))//":"//str(int(slityxc+10.0))//"]"
          imcopy (flatim//"_"//str(i)//"_wl", flatim//"_wl"//sec[i], ver-)
	  wcscopy (flatim//"_wl", flatim//"_"//str(i)//"_wl", verb-)

	  imstat (flatim//"_wl"//statsec[i], fields="midpt", format-) | scan (flat[i])
	  flatnor = flat[i]/flat[1]
	  #imarith (filin//"_"//str(i)//"_wl", "/", flatnor, filin//"_"//str(i)//"_wl", verb-)
          imdelete (filin//"_temp_"//str(i)//"_wl", ver-, >& "dev$null")
	  #imarith (filin//"_"//str(i)//"_wl", "/", flatnor, filin//"_temp_"//str(i)//"_wl", verb-)
	  imarith (filin//"_"//str(i)//"_wl", "/", flatim//"_"//str(i)//"_wl", filin//"_temp_"//str(i)//"_wl", verb-)
          imdelete (filin//"_"//str(i)//"_wl", ver-, >& "dev$null")
	  imrename (filin//"_temp_"//str(i)//"_wl", filin//"_"//str(i)//"_wl", verb-)
	  #print (i, slitx, flatnor, flat[i], statsec[i], >> flatim//"_av.log")
	imcopy (flatim//"_"//str(i)//"_wl", flatlam//sec[i], ver-)
	wcscopy (flatlam, flatim//"_"//str(i)//"_wl", verb-)
	}
	}

        imcopy (filin//"_"//str(i)//"_wl", filelam//sec[i], ver-)
	wcscopy (filelam, filin//"_"//str(i)//"_wl", verb-)
	wcscopy (filetra, filin//"_"//str(i)//"_wl", verb-)

	#_________________________________________________________________________
	#Block_5 - Bring a chosen skyline in all slitlets into the same y in pixels. 
	#        - If asked to do so, tilt a skyline in a slitlet to horizontal position.
	#_________________________________________________________________________

	imdelete (filin//"_tmp", ver-, >& "dev$null")
	if (doflat) {imdelete (flatim//"_tmp", ver-, >& "dev$null")}

	if (stype == "rectangular") {
	#if (slit_orient) {
	#if (fitlin) {
	if (slit_orient && fitlin && fitslit[i]) {
	for (j = ix1; j <= ix2; j = j + 2) {
	imdelete (filin//"_tmp", ver-, >& "dev$null")
	secj = "["//str(j)//":"//str(j+1)//",*]"
	omlinefit (filelam, xposlit=real(j), yposlit=slitlam_sky) 
	fields (omlinefit.logfile, fields="1", lines=4) | scan (slitlam0_sky)
	#slityxc = (slitlam0_sky - lamcen)/dw + pixcen
	slityxc = (slitlam0_sky - lamini)/dw + 1.0
	imlintran (filelam//secj, filin//"_tmp", xrot=0., yrot=0.0, xmag=1.0, ymag=1.0, yin=slityxc, yout=slity0, boundar="constant", constant=0.0, ver-)
	#print(i, j, slitx, slityxc, slity0, slito)
	if (doflat) {
		imdelete (flatim//"_tmp", ver-, >& "dev$null")
		imlintran (flatlam//secj, flatim//"_tmp", xrot=0., yrot=0.0, xmag=1.0, ymag=1.0, yin=slityxc, yout=slity0, boundar="constant", constant=0.0, ver-) 
        	imcopy (flatim//"_tmp", flattra//secj, ver-)
		}
        imcopy (filin//"_tmp", filetra//secj, ver-)
		}   #for end
		}   #end orient & fitlin
	if (!slit_orient && fitlin && fitslit[i]) {
	omlinefit (filelam, xposlit=slitx, yposlit=slitlam_sky) 
	fields (omlinefit.logfile, fields="1", lines=4) | scan (slitlam0_sky)
	#slityxc = (slitlam0_sky - lamcen)/dw + pixcen
	slityxc = (slitlam0_sky - lamini)/dw + 1.0
	#print(slityxc, slitlam0_sky, slity0)
	imlintran (filelam//sec[i], filin//"_"//str(i), xrot=0., yrot=0.0, xmag=1.0, ymag=1.0, yin=slityxc, yout=slity0, boundar="constant", constant=0.0, ver-)
        fields (omlinefit.logfile, fields="1-7", lines=4) | scan (center, cont, flux, eqw, core, gfwhm, lfwhm)
        printf ("%9.2f %9.2f %9.2f %9.0f %9.3f %9.2f %6.2f %6.2f\n", slitx, center, cont, flux, eqw, core, gfwhm, lfwhm, >> "splot_auto_gaussfit_parameters.log")
        imcopy (filin//"_"//str(i), filetra//sec[i], ver-)
	} 
	if (!slit_orient && !fitlin) {imcopy (filelam//sec[i], filetra//sec[i], ver-) }

	if (doflat) {
		imlintran (flatlam//sec[i], flatim//"_"//str(i), xrot=0., yrot=0.0, xmag=1.0, ymag=1.0, yin=slityxc, yout=slity0, boundar="constant", constant=0.0, ver-) 
        	imcopy (flatim//"_"//str(i), flattra//sec[i], ver-)
		}
	print(i, stype, " ", filin, sec[i], " ", slity, " ", slityx, " ", slitx, ix1," ", ix2)
	print(i, stype, " ", filin, sec[i], " ", slity, " ", slityx, " ", slitx, ix1," ", ix2, >> "osiris_mos_reduction.log")
	}    #end if rectangular
	if (stype == "circular" && show_circular) { 
		imcopy (filelam//sec[i], filetra//sec[i], ver-) 
	print(i, stype, " ", filin, sec[i], " ", slity, " ", slityx, " ", slitx, ix1," ", ix2)
	print(i, stype, " ", filin, sec[i], " ", slity, " ", slityx, " ", slitx, ix1," ", ix2, >> "osiris_mos_reduction.log")
			}
	if (clevel > 0) {imdelete (filin//"_"//str(i), ver-, >& "dev$null")}
        if (clevel > 1 && i != iref) {imdelete (filin//"_"//str(i)//"_wl", ver-, >& "dev$null")}

	imdelete (filin//"_tmp", ver-, >& "dev$null")
	if (doflat) {
		imdelete (flatim//"_"//str(i), ver-, >& "dev$null")
        	imdelete (flatim//"_"//str(i)//"_wl", ver-, >& "dev$null")
		imdelete (flatim//"_tmp", ver-, >& "dev$null")
		}
test:
	}

	if (stype == "rectangular" && slit_orient && !fitlin) {
	  imdelete (filetra, ver-, >& "dev$null")
	  imcopy (filelam, filetra, ver-)
	}
	wcscopy (filetra, filin//"_"//str(iref)//"_wl", verb-)
	hedit (filetra, "DC-FLAG", 0, add+, ver-, show-)
	hedit (filetra, "ARCFILE", fillamp, add+, ver-, show-)
	hedit (filetra, "FLATFILE", flatim, add+, ver-, show-)
	hedit (filetra, "TILTSLIT", slit_orient, add+, ver-, show-)
	hedit (filetra, "LAMDACEN", slitlam_sky, add+, ver-, show-)
	hedit (filetra, "SLITREJ", slitreject, add+, ver-, show-)
	#hedit (filetra, "", , add+, ver-, show-)
	#imdelete (filelam, ver-, >& "dev$null")
	if (doflat) {imdelete (flatlam, ver-, >& "dev$null")}
	if (dosens) {
	imdelete (filetra//"_cal", ver-, >& "dev$null")
	calibrate (filetra, filetra//"_cal", extinct+, flux+, extinction=omstd.extinct, sensiti=sensfun, ignorea-, fnu-)
	}
	}
	print("Wavelength calibrated data are stored in ", filetra)
goexit:
	print(" ")
end
