procedure omreduce(filnam)

string  filnam = "gtc14a_mos1abc"   {prompt="File Name"}
string  filarc = "auto"             {prompt="Comparison arc file [auto|gtc14a_p1arc_m_HgArNe]"}
string  filflat= ""      {prompt="Master Flat file [gtc14a_p1_m_flat_b or empty]"}
bool    tilt_slit = no   	    {prompt="Correct for Slit tilt?"} 
bool    fiducial  = no   	    {prompt="Retain fiducial stars?"} 
real	lamcen    =5577.838           {prompt="Lambda of a sky line in Ang"}
#string  filout = ""                {prompt="Root name for Output File"}
#(w1     =                INDEF) Starting wavelength
#(w2     =                INDEF) Ending wavelength
#(dw     =                INDEF) Wavelength interval per pixel
#(nw     =                INDEF) Number of output pixels
#int	clevel  = 0			{prompt="Clean Level [2=del all intermediate fits] [0=retain all]"}


#input datafiles: ds9_head.txt, database/idarcoR1000B, MOS_lambda_calib.dat, identify_template

begin
	string filin, cutc46, sn, stype, sec[999], comm1, filetra, filelam, secj
	string	splotfillog, grism, fillamp, flatim, statsec[999]
	string	flattra, flatlam
	real	slitx, slity, slitw, slitl, slito, slitr, xbin, ybin, slityx, dyxj
	real	lamc, lam1, lam2, y5577, slity0, dyx, slityx_5577
	real	aa, bb, cc, ee, ff
	real	slityxc, ce[4], lamref_corr
	real	slitlam_sky, slitlam0_sky, pixref, lamref, dlam, npix, dlam1
	real	flatnor, flat[999], ydist, ydistmin
	int	i1, nslits, ix1, ix2, islit, islitx, iref, slitxref, clevel
	bool	slit_orient, doflat, show_circular
        real   center, cont, flux, eqw, core, gfwhm, lfwhm

        filin = filnam
	fillamp = filarc 
	slitlam_sky = lamcen
	flatim = filflat        #"gtc14a_p1_m_flat_b"
	doflat = yes
	if (flatim == "") {doflat = no}
	show_circular = fiducial
	slit_orient = tilt_slit
	clevel = 0
	filetra = filin//"_wl"; filelam = filin//"_t"
	if (slit_orient) {filetra = filin//"_wl_tlt"}
	imdelete (filetra, ver-, >& "dev$null"); imdelete (filelam, ver-, >& "dev$null")
	delete ("splot_auto_gaussfit_parameters.log", ver-, >& "dev$null")

        hselect (filin, "GRISM NAXIS2", expr+) | scan (grism, npix)

	if (doflat) {
		flattra = flatim//"_wl"; flatlam = flatim//"_t"
		imdelete (flattra, ver-, >& "dev$null"); imdelete (flatlam, ver-, >& "dev$null")
		delete (flatim//"_av.log", ver-, >& "dev$null")
        	imarith (flatim, "*", 0.0, flattra, ver-)
        	imarith (flatim, "*", 0.0, flatlam, ver-)
		#imdelete (flatim//"_wl", ver-, >& "dev$null") #imarith (flatim, "*", 0.0, flatim//"_wl", ver-)
	}
        imarith (filin, "*", 0.0, filetra, ver-)
        imarith (filin, "*", 0.0, filelam, ver-)

        omslits (filin, verb-)
        nslits = omslits.nslitlets
        list = omslits.out

	if (nslits == 1) {
        #print (" Running dispcor to resample linearly. Takes around 5 minutes.")
        #print ("Wavelength reference: ")
        #hselect (filin, "REFSPEC1", expr+)
	print ("*** Longslit spectrum: Use olreduce ***")
	} else {

	iref = 1; ydistmin = 500.
        i1 = 0
        for (i = 1; i <= nslits; i = i + 1) {
        i1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype)
        sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"
	ydist = abs(slity-995.0)
	if (ydist < ydistmin) {ydistmin = ydist; iref = i; slitxref = slitx}
	}
	print ("Reference Slitlet: i=", iref, "x=", slitxref, "ydist=",ydistmin)

	if (fillamp != "auto") {
        match (grism, "gtcinputs$MOS_lambda_calib.dat") | fields (fields="4-9") | scan (dlam1,aa,bb,cc,ee,ff)
	#lamcen = aa + bb*995 + cc*995**2
	lamref = aa + bb*1.0 + cc*1.0**2
	#pixref = 1.0; lamref = lamcen - (real(npix)/2.0 - pixref)*dlam1

	imdelete (filin//"_"//str(iref), ver-, >& "dev$null")
	imdelete (filin//"_"//str(iref)//"_wl", ver-, >& "dev$null")
	imcopy (filin//sec[iref], filin//"_"//str(iref), ver-)
	hedit (filin//"_"//str(iref), "REFSPEC1", fillamp//"_"//str(iref), add+, ver-, show-)
        dispcor (filin//"_"//str(iref), filin//"_"//str(iref)//"_wl", w1=lamref, dw=dlam1, nw=npix, verb-)
        hselect (filin//"_"//str(iref)//"_wl", "NAXIS2 CRVAL2 CDELT2, CRPIX2", expr+) | scan(npix, lamref, dlam1, pixref)
        #hselect (filin//"_"//str(iref)//"_wl", "NAXIS2 CRVAL2 CDELT2, CRPIX2", expr+) 
	#hselect (filin//"_"//str(i)//"_wl", "CRPIX2 CRVAL2 CDELT2", expr+) | scan(pixref, lamref, dlam)

        imcopy (filin//"_"//str(iref)//"_wl", filelam//sec[iref], ver-)
	wcscopy (filelam, filin//"_"//str(iref)//"_wl", verb-)
        wcscopy (filetra, filin//"_"//str(iref)//"_wl", verb-)
        omlinefit (filelam, xposlit=slitxref, yposlit=slitlam_sky)
        splotfillog = omlinefit.logfile
        fields (splotfillog, fields="1", lines=4) | scan (slitlam0_sky)
        lamref_corr = lamref + (slitlam_sky - slitlam0_sky)
        hedit (filetra, "CRVAL2", lamref_corr, add+, ver-, show-)
        slity0 = (slitlam0_sky - lamref)/dlam1 + pixref
	}

        list = omslits.out
        i1 = 0
        for (i = 1; i <= nslits; i = i + 1) {
        i1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype)
        #sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"

	#_________________________________________________________________________
	#Block_3 - Wavelength Calibrate each slitlet either by previously identified arclamp
	#          solutions or automatically using an emperical equation for the dispersion.
	#          In either case dispersion is fixed at the value of slitlet 1 (or slitrefi - not implemented)
	#_________________________________________________________________________

	imdelete (filin//"_"//str(i), ver-, >& "dev$null")
	imdelete (filin//"_"//str(i)//"_wl", ver-, >& "dev$null")
	imcopy (filin//sec[i], filin//"_"//str(i), ver-)

	if (fillamp == "auto") {
	  delete ("database/id"//filin//"_arc_emp", ver-, >& "dev$null")
	  hedit (filin//"_"//str(i), "REFSPEC1", filin//"_arc_emp", add+, ver-, show-)
          omwcal_coef (slity, order=1, grating=grism) | scan (ce[4], ce[3], ce[2], ce[1])
          #print (ce[1], ce[2], ce[3], ce[4])
          copy ("gtcinputs$identify_template", "database/id"//filin//"_arc_emp", verb-)
          print (ce[1], >> "database/id"//filin//"_arc_emp")
          print (ce[2], >> "database/id"//filin//"_arc_emp")
          print (ce[3], >> "database/id"//filin//"_arc_emp")
          print (ce[4], >> "database/id"//filin//"_arc_emp")
	  } else {
	  hedit (filin//"_"//str(i), "REFSPEC1", fillamp//"_"//str(i), add+, ver-, show-)
	  }
        #if (i == 1) {
	#	dispcor (filin//"_"//str(i), filin//"_"//str(i)//"_wl", verb-)
	#hselect (filin//"_"//str(i)//"_wl", "NAXIS2 CRVAL2 CDELT2", expr+) | scan(npix, lamref, dlam1)
	#	} else {
		dispcor (filin//"_"//str(i), filin//"_"//str(i)//"_wl", w1=lamref, dw=dlam1, nw=npix, verb-)
	#	}
	hselect (filin//"_"//str(i)//"_wl", "CRPIX2 CRVAL2 CDELT2", expr+) | scan(pixref, lamref, dlam)
	#print (pixref, lamref, dlam)

	#slitlam_sky = 5577.0
	#_________________________________________________________________________
	#Block_4 - If asked, normalize the flats at lam=slitlam_sky of slitref (=slilet 1) and
	#          divide each slitlet spectrum by the normalized flat
	#_________________________________________________________________________
        imdelete (flatim//"_"//str(i), ver-, >& "dev$null")
        imdelete (flatim//"_"//str(i)//"_wl", ver-, >& "dev$null")

	if (doflat) {
	  imcopy (flatim//sec[i], flatim//"_"//str(i), ver-)
	if (fillamp == "auto") {
	  hedit (flatim//"_"//str(i), "REFSPEC1", filin//"_arc_emp", add+, ver-, show-)
		} else {
	  hedit (flatim//"_"//str(i), "REFSPEC1", fillamp//"_"//str(i), add+, ver-, show-)
		}
	  dispcor (flatim//"_"//str(i), flatim//"_"//str(i)//"_wl", dw=dlam1, nw=npix, verb-)
	slityxc = (slitlam_sky - lamref)/dlam + pixref
	  statsec[i] = "["//str(ix1)//":"//str(ix2)//","//str(int(slityxc-10.0))//":"//str(int(slityxc+10.0))//"]"
          imcopy (flatim//"_"//str(i)//"_wl", flatim//"_wl"//sec[i], ver-)
	  wcscopy (flatim//"_wl", flatim//"_"//str(i)//"_wl", verb-)

	  imstat (flatim//"_wl"//statsec[i], fields="midpt", format-) | scan (flat[i])
	  flatnor = flat[i]/flat[1]
	  #imarith (filin//"_"//str(i)//"_wl", "/", flatnor, filin//"_"//str(i)//"_wl", verb-)
          imdelete (filin//"_temp_"//str(i)//"_wl", ver-, >& "dev$null")
	  imarith (filin//"_"//str(i)//"_wl", "/", flatnor, filin//"_temp_"//str(i)//"_wl", verb-)
          imdelete (filin//"_"//str(i)//"_wl", ver-, >& "dev$null")
	  imrename (filin//"_temp_"//str(i)//"_wl", filin//"_"//str(i)//"_wl", verb-)
	  print (i, slitx, flatnor, flat[i], statsec[i], >> flatim//"_av.log")
	imcopy (flatim//"_"//str(i)//"_wl", flatlam//sec[i], ver-)
	wcscopy (flatlam, flatim//"_"//str(i)//"_wl", verb-)
	}

        imcopy (filin//"_"//str(i)//"_wl", filelam//sec[i], ver-)
	wcscopy (filelam, filin//"_"//str(i)//"_wl", verb-)

	#if (i == 1) {
	##hselect (filin//"_"//str(i)//"_wl", "NAXIS2 CRVAL2 CDELT2", expr+) | scan(npix, lamref, dlam1)
	#wcscopy (filetra, filin//"_"//str(i)//"_wl", verb-)
	#omlinefit (filelam, xposlit=slitx, yposlit=slitlam_sky) 
	#splotfillog = omlinefit.logfile
	#fields (splotfillog, fields="1", lines=4) | scan (slitlam0_sky)
	#lamref_corr = lamref + (slitlam_sky - slitlam0_sky)
	#hedit (filetra, "CRVAL2", lamref_corr, add+, ver-, show-)
	#slity0 = (slitlam0_sky - lamref)/dlam1 + pixref
	#}
        imdelete (filin//"_"//str(i), ver-, >& "dev$null")
        #imdelete (filin//"_"//str(i)//"_wl", ver-, >& "dev$null")

	#_________________________________________________________________________
	#Block_5 - Bring a chosen skyline in all slitlets into the same y in pixels. 
	#        - If asked to do so, tilt a skyline in a slitlet to horizontal position.
	#_________________________________________________________________________

	imdelete (filin//"_tmp", ver-, >& "dev$null")
	if (doflat) {imdelete (flatim//"_tmp", ver-, >& "dev$null")}

	if (stype == "rectangular") {
	if (slit_orient) {
	print(i, stype, " ", filin, sec[i], " ", slity, " ", slityx, " ", slitx, " ", slity0, " ", ix1," ", ix2)
	print(i, stype, " ", filin, sec[i], " ", slity, " ", slityx, " ", slitx, " ", slity0, " ", ix1," ", ix2, >> "osiris_mos_reduction.log")
	for (j = ix1; j <= ix2; j = j + 2) {
	imdelete (filin//"_tmp", ver-, >& "dev$null")
	secj = "["//str(j)//":"//str(j+1)//",*]"
	omlinefit (filelam, xposlit=real(j), yposlit=slitlam_sky) 
	fields (splotfillog, fields="1", lines=4) | scan (slitlam0_sky)
	slityxc = (slitlam0_sky - lamref)/dlam + pixref
	#print(j, slityxc, slitlam0_sky)
	imlintran (filelam//secj, filin//"_tmp", xrot=0., yrot=0.0, xmag=1.0, ymag=1.0, yin=slityxc, yout=slity0, boundar="constant", constant=0.0, ver-)
	if (doflat) {
		imdelete (flatim//"_tmp", ver-, >& "dev$null")
		imlintran (flatlam//secj, flatim//"_tmp", xrot=0., yrot=0.0, xmag=1.0, ymag=1.0, yin=slityxc, yout=slity0, boundar="constant", constant=0.0, ver-) 
        	imcopy (flatim//"_tmp", flattra//secj, ver-)
		}
        imcopy (filin//"_tmp", filetra//secj, ver-)
		}   #for end
		} else {
	omlinefit (filelam, xposlit=slitx, yposlit=slitlam_sky) 
	fields (splotfillog, fields="1", lines=4) | scan (slitlam0_sky)
	slityxc = (slitlam0_sky - lamref)/dlam + pixref
	#print(slityxc, slitlam0_sky, slity0)
	imlintran (filelam//sec[i], filin//"_"//str(i), xrot=0., yrot=0.0, xmag=1.0, ymag=1.0, yin=slityxc, yout=slity0, boundar="constant", constant=0.0, ver-)
        fields (splotfillog, fields="1-7", lines=4) | scan (center, cont, flux, eqw, core, gfwhm, lfwhm)
        printf ("%9.2f %9.2f %9.2f %9.0f %9.3f %9.2f %6.2f %6.2f\n", slitx, center, cont, flux, eqw, core, gfwhm, lfwhm, >> "splot_auto_gaussfit_parameters.log")

	if (doflat) {
		imlintran (flatlam//sec[i], flatim//"_"//str(i), xrot=0., yrot=0.0, xmag=1.0, ymag=1.0, yin=slityxc, yout=slity0, boundar="constant", constant=0.0, ver-) 
        	imcopy (flatim//"_"//str(i), flattra//sec[i], ver-)
		}
        imcopy (filin//"_"//str(i), filetra//sec[i], ver-)
	print(i, stype, " ", filin, sec[i], " ", slity, " ", slityx, " ", slitx, ix1," ", ix2)
	print(i, stype, " ", filin, sec[i], " ", slity, " ", slityx, " ", slitx, ix1," ", ix2, >> "osiris_mos_reduction.log")
	}   #end if orient
	}    #end if rectangular
	if (stype == "circular" && show_circular) { 
		imcopy (filelam//sec[i], filetra//sec[i], ver-) 
	print(i, stype, " ", filin, sec[i], " ", slity, " ", slityx, " ", slitx, ix1," ", ix2)
	print(i, stype, " ", filin, sec[i], " ", slity, " ", slityx, " ", slitx, ix1," ", ix2, >> "osiris_mos_reduction.log")
			}
	if (clevel > 0) {imdelete (filin//"_"//str(i), ver-, >& "dev$null")}
        if (clevel > 1) {imdelete (filin//"_"//str(i)//"_wl", ver-, >& "dev$null")}

	imdelete (filin//"_tmp", ver-, >& "dev$null")
	if (doflat) {
		imdelete (flatim//"_"//str(i), ver-, >& "dev$null")
        	imdelete (flatim//"_"//str(i)//"_wl", ver-, >& "dev$null")
		imdelete (flatim//"_tmp", ver-, >& "dev$null")
		}
	}

	hedit (filetra, "ARCFILE", fillamp, add+, ver-, show-)
	hedit (filetra, "FLATFILE", flatim, add+, ver-, show-)
	hedit (filetra, "TILTSLIT", slit_orient, add+, ver-, show-)
	hedit (filetra, "LAMDACEN", slitlam_sky, add+, ver-, show-)
	#hedit (filetra, "", , add+, ver-, show-)
	imdelete (filelam, ver-, >& "dev$null")
	if (doflat) {imdelete (flatlam, ver-, >& "dev$null")}
	}
end
