procedure omsky1d(filein)

#This script obtains a median and rms of all sky sections given in the file secfil
#which are then compared with the values at the corresponding lambda of the object section.
#Alternatively if the filein contains a section "[]", secfil is ignored.
#The task is meant to be an auxillary tool to omskysub, in such a way that the omskysub
#task writes the secfil based on the skytype parameter value.
#Stores the 1d sky and rms files, as well as a 2d sky combining all the sky sections.

string	filein = "gtc14aob4_object_sum_wl_tlt"	{prompt="Input filename"}
string	secfil = "secfile"			{prompt="File containing sections for object and sky"}
string	method = "median"			{prompt="Sky extration method [median, percent]"}
real	percent= 20.0				{prompt="Percentile value for sky [1-50]"}
real	ksigrms= 3.0				{prompt="ksigma rejection [>1.0]"}
string	skymed = ""				{prompt="Output 1d sky spectrum"}
string	skyrms = ""				{prompt="Output 1d sky rms spectrum"}

begin
	string	filin, fil2d, skycol, algor, objsec, stype
	string	filetmp1, filetmp2, outtyp, sfile, filsky, isec, skysec[99]
	real	frac, krms, slitx, slity, slityx
	int	dsky, ndim, i, k, j1, j2, ilin, nsky, islit, ix1, ix2

	fil2d = filein; algor = method; frac = percent/100.0
	krms = ksigrms; sfile = secfil

	j1 = strstr("[", fil2d)
	#print(j1)
	if (j1 != 0) { 
			j2 = strstr("]", fil2d); nsky=1 
			skysec[1] = substr(fil2d, j1, j2)
			fil2d = substr(fil2d, 1, j1-1)
		     } else  {
		tinfo (sfile, ttout-); nsky = tinfo.nrows
		if (strstr("head.dat", sfile) == 0){
        for (k = 1; k <= nsky; k = k + 1) {fields(sfile, "1", lines=str(k)) | scan(skysec[k])}
						} else {
        j1 = 0; k = 0
	list = sfile
        for (i = 1; i <= tinfo.nrows; i = i + 1) {
        j1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype)
	if (stype == "rectangular"){k = k + 1; skysec[k] = "["//str(ix1)//":"//str(ix2)//",*]" }
        					}
			nsky = k
			}
			}
	#print("Object section = ", objsec, " Nsky = ", j)
	#print(" Nsky = ", nsky)
	
	filsky = fil2d//"_tskys" 
        imexpr ("a*0", filsky, fil2d, verb-)

	j2 = 0
        for (k = 1; k <= nsky; k = k + 1) {
		filin = fil2d//"_tsky"//str(k); imdelete (filin, ver-, >& "dev$null")
        	imcopy (fil2d//skysec[k], filin, verb-)
		hselect (filin, "NAXIS1", expr+) | scan(dsky)
		j1 = j2 + 1; j2 = j1 + dsky - 1; isec = "["//str(j1)//":"//str(j2)//",*]"
        	imcopy (filin, filsky//isec, verb-); imdelete (filin, ver-, >& "dev$null")
		#print(k, " ", isec, " ", dsky)
	}
	filin = fil2d//"_sky2d_allsky"; imdelete (filin, ver-, >& "dev$null")
        imcopy (filsky//"[1:"//str(j2)//",*]", filin, ver-); imdelete (filsky, ver-, >& "dev$null")

        filetmp1 = fil2d//"_sky1d_med";  imdelete (filetmp1, ver-, >& "dev$null")
        filetmp2 = fil2d//"_sky1d_rms";  imdelete (filetmp2, ver-, >& "dev$null")
	hselect (filin, "NAXIS1", expr+) | scan(dsky)

        if (algor == "percent") {
        	imexpr("sort(a)", filetmp1, filin, verb-)
        	skycol = "["//str(int(frac*dsky))//",*]"  # print(skycol)
		imdelete (filin, ver-, >& "dev$null"); imrename (filetmp1, filin, verb-)
        	imcopy (filin//skycol, filetmp1, ver-)
        			}


	if (algor == "median") {
        imexpr("median(a)", filetmp1, filin, verb-)
	hselect (filetmp1, "NAXIS", expr+) | scan(ndim)
	frac = 1.0
	if (ndim > 1) {scopy (filetmp1, "filetmp1_1", bands=1, verbo-)
			imdelete (filetmp1, ver-, >& "dev$null")
			imrename ("filetmp1_1", filetmp1, verb-)
			}
				}

	skysec = "[1,"//str(int(frac*dsky))//",*]"
        imexpr("stddev(a, "//str(krms)//")", filetmp2, filin//skysec, verb-)
        #imexpr("stddev(a, "//str(krms)//")", filetmp2, filin, verb-)
	hselect (filetmp2, "NAXIS", expr+) | scan(ndim)
	if (ndim > 1) {scopy (filetmp2, "filetmp2_2", bands=1, verbo-)
			imdelete (filetmp2, ver-, >& "dev$null")
			imrename ("filetmp2_2", filetmp2, verb-)
			}
			#splot (filetmp2)

	skymed = filetmp1
	skyrms = filetmp2

end
