procedure omsky2d(filein)

#This script uses the median and rms from omsky1d to compare 
#with the values at the corresponding lambda of the object section.
#If the difference is less less than ksigma*rms, the "object" data are set to zero,
#otherwise sky subtracted data are substituted as "object" data. 
#The task is meant to be an auxillary tool to omskysub, or can be used a standalone
#task for sky subtraction. 
#If only one object has to be analyzed, object section can be given as "[]" in filein.
#For the analysis of multiple objects, write the sections in secfil or directly
#give the "?head.dat" as a secfil

string	filein = "gtc14aob4_object_sum_wl_tlt"	{prompt="Input filename"}
string  sky1d  = "DEFAULT"               	{prompt="Input 1d sky spectrum"}
string  rms1d  = "DEFAULT"               	{prompt="Input 1d sky rms spectrum"}
string	secfil = "secfile"			{prompt="File containing sections for objects"}
string	fileout= "DEFAULT"			{prompt="Output Sky subtracted filename"}
real	ksigma = 1.0				{prompt="ksigma rejection [>1.0]"}
string	otype  = "sky"				{prompt="Type of output [sky, obj]"}

begin
	string	filin, fil2d, filout, objsec[199], filouttmp
	string	filtmp1, filtmp2, filtmp3, outtyp, sfile
	real	ksig
	int	i, j, k, j1, j2, ilin, dobj, nobj

	fil2d = filein; filout = fileout
	ksig = ksigma; outtyp = otype; sfile = secfil; filtmp1 = sky1d; filtmp2 = rms1d
	#if (strupr(filtmp1) == "DEFAULT"){filtmp1 = omsky1d.skymed}
	#if (strupr(filtmp1) == "DEFAULT"){filtmp2 = omsky1d.skyrms}
	if (strupr(filtmp1) == "DEFAULT"){filtmp1 = "gtc17aob001_object_all_wl_tlt_sky1d_med"}
	if (strupr(filtmp1) == "DEFAULT"){filtmp2 = "gtc17aob001_object_all_wl_tlt_sky1d_rms"}
	#print(filtmp1, " ", filtmp2)

        j1 = strstr("[", fil2d)
        #print(j1)
        if (j1 != 0) {
                        j2 = strstr("]", fil2d); nobj=1
                        objsec[1] = substr(fil2d, j1, j2)
                        fil2d = substr(fil2d, 1, j1-1)
                     } else  {
                tinfo (sfile, ttout-); nobj = tinfo.nrows
                if (strstr("head.dat", sfile) == 0){
        for (k = 1; k <= nobj; k = k + 1) {fields(sfile, "1", lines=str(k)) | scan(objsec[k])}
                                                } else {
        j1 = 0; k = 0
        list = sfile
        for (i = 1; i <= tinfo.nrows; i = i + 1) {
        j1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype)
        if (stype == "rectangular"){k = k + 1; objsec[k] = "["//str(ix1)//":"//str(ix2)//",*]" }
                                                }
                        nobj = k
                        }
                        }
        #print(" Nobj = ", nobj)

        filtmp3 = "temp_file_tmp3";  imdelete (filtmp3, ver-, >& "dev$null")

	if (strupr(filout) == "DEFAULT"){filout = fil2d//"_sky2d_"//str(outtyp)}
	imdelete (filout, ver-, >& "dev$null")
        imexpr ("a*0", filout, fil2d, verb-)

        for (k = 1; k <= nobj; k = k + 1) {
	filin = fil2d//"_tobj"; imdelete (filin, ver-, >& "dev$null")
	filouttmp = fil2d//"_outtmp"; imdelete (filouttmp, ver-, >& "dev$null")
        imcopy (fil2d//objsec[k], filin, ver-)
        imexpr ("a*0", filouttmp, filin, verb-)
	hselect (filin, "NAXIS1", expr+) | scan(dobj)
        for (i = 1; i <= dobj; i = i + 1) {
	imdelete (filtmp3, ver-, >& "dev$null")
	if (outtyp == "sky") {
	imexpr ("abs(a-b) < d*c ? a : b", filtmp3, filin//"["//str(i)//",*]", filtmp1, filtmp2, ksig, verb-) 
	} else {
	imexpr ("abs(a-b) < d*c ? 0 : a-b", filtmp3, filin//"["//str(i)//",*]", filtmp1, filtmp2, ksig, verb-)
	}
        imcopy (filtmp3, filouttmp//"["//str(i)//",*]", ver-) 
	#splot (filtmp3)
	}
	imcopy (filouttmp, filout//objsec[k], ver-)
	}
	if (nobj == 1){imdelete (filout, ver-, >& "dev$null"); imrename (filouttmp, filout, verb-)}

	imdelete (filin, ver-, >& "dev$null")
	imdelete (filtmp3, ver-, >& "dev$null")
	imdelete (filouttmp, ver-, >& "dev$null")

end
