procedure omsky2d(filein, secfil)

#This script obtains a median and rms of all sky sections given in the file secfil
#which are then compared with the values at the corresponding lambda of the object section.
#If the difference is less less than ksigma*rms, the "object" data are set to zero,
#otherwise sky subtracted data are substituted as "object" data. 
#The task is meant to be an auxillary tool to omskysub, in such a way that the omskysub
#task writes the secfil based on the skytype parameter value.

string	filein = "gtc14aob4_object_sum_wl_tlt"	{prompt="Input filename"}
string	secfil = "secfile"			{prompt="File containing sections for object and sky"}
string	fileout= "DEFAULT"			{prompt="Output Sky subtracted filename"}
string	method = "median"			{prompt="Sky extration method [median, percent]"}
real	percent= 20.0				{prompt="Percentile value for sky [1-50]"}
real	ksigma = 1.0				{prompt="ksigma rejection [>1.0]"}
real	ksigrms= 3.0				{prompt="ksigma rejection [>1.0]"}
string	otype  = "sky"				{prompt="Type of output [sky, obj]"}

begin
	string	filin, fil2d, filout, skycol, filetmp1, algor, objsec
	string	filetmp2, filetmp3, outtyp, sfile, filsky, isec, skysec[99]
	real	frac, ksig, krms
	int	dsky, ndim, i, j, k, j1, j2, ilin, dobj

	fil2d = filein; filout = fileout; algor = method; frac = percent/100.0
	ksig = ksigma; krms = ksigrms; outtyp = otype; sfile = secfil
	if (strupr(filout) == "DEFAULT"){filout = fil2d//"_sky2d_"//str(outtyp)}

	i1 = strstr("[", fil2d)
	if (i1 != 0) {
		i2 = strstr("]", fil2d); j=1; skysec[j] = substr(fil2d, i1, i2)
		} else {
	tinfo (sfile, ttout-)
	j = 0
        for (k = 1; k <= tinfo.nrows; k = k + 1) {
	  fields(sfile, "1-2", lines=str(k)) | scan(ilin, isec)
	  if (ilin == 0) {objsec = isec} else {j = j+1; skysec[j] = isec}
	}
	}
	#print("Object section = ", objsec, " Nsky = ", j)
	print(" Nsky = ", j)
	
	filsky = fil2d//"_tskys" 
        imexpr ("a*0", filsky, fil2d, verb-)

	j2 = 0
        for (k = 1; k <= j; k = k + 1) {
	filin = fil2d//"_tsky"//str(k)
	imdelete (filin, ver-, >& "dev$null")
        imcopy (fil2d//skysec[k], filin, verb-)
	hselect (filin, "NAXIS1", expr+) | scan(dsky)
	j1 = j2 + 1; j2 = j1 + dsky - 1; isec = "["//str(j1)//":"//str(j2)//",*]"
        imcopy (filin, filsky//isec, verb-)
	imdelete (filin, ver-, >& "dev$null")
	#print(k, " ", isec, " ", dsky)
	}
	filin = fil2d//"_sky2d_allsky"
	imdelete (filin, ver-, >& "dev$null")
        imcopy (filsky//"[1:"//str(j2)//",*]", filin, ver-)
	imdelete (filsky, ver-, >& "dev$null")

        filetmp1 = fil2d//"_sky2d_med";  imdelete (filetmp1, ver-, >& "dev$null")
        filetmp2 = fil2d//"_sky2d_rms";  imdelete (filetmp2, ver-, >& "dev$null")
        filetmp3 = "temp_file_tmp3";  imdelete (filetmp3, ver-, >& "dev$null")
	imdelete (filout, ver-, >& "dev$null")
	hselect (filin, "NAXIS1", expr+) | scan(dsky)

        #imexpr ("a*0", filout, filin, verb-)

	if (algor == "percent") {
        imexpr("sort(a)", filetmp1, filin, verb-)
        skycol = "["//str(int(frac*dsky))//",*]"
        #imcopy (filetmp1//skycol, filout, ver-)
        imcopy (filetmp1//skycol, filetmp1, ver-)
	}

	if (algor == "median") {
        imexpr("median(a)", filetmp1, filin, verb-)
	hselect (filetmp1, "NAXIS", expr+) | scan(ndim)
	if (ndim > 1) {scopy (filetmp1, "filetmp1_1", bands=1, verbo-)
			imdelete (filetmp1, ver-, >& "dev$null")
			imrename ("filetmp1_1", filetmp1, verb-)
			}
        #imcopy (filetmp1, filout, ver-)
	}

        #imexpr("stddev(a, 1.0)", filetmp2, filin, verb-)
        imexpr("stddev(a, "//str(krms)//")", filetmp2, filin, verb-)
	hselect (filetmp2, "NAXIS", expr+) | scan(ndim)
	if (ndim > 1) {scopy (filetmp2, "filetmp2_2", bands=1, verbo-)
			imdelete (filetmp2, ver-, >& "dev$null")
			imrename ("filetmp2_2", filetmp2, verb-)
			}
	#splot (filetmp2)

	filin = fil2d//"_tobj"
	imdelete (filin, ver-, >& "dev$null")
        imcopy (fil2d//objsec, filin, ver-)
        imexpr ("a*0", filout, filin, verb-)
	hselect (filin, "NAXIS1", expr+) | scan(dobj)
        for (i = 1; i <= dobj; i = i + 1) {
	imdelete (filetmp3, ver-, >& "dev$null")
	if (outtyp == "sky") {
	imexpr ("abs(a-b) < d*c ? a : b", filetmp3, filin//"["//str(i)//",*]", filetmp1, filetmp2, ksig, verb-) 
	} else {
	imexpr ("abs(a-b) < d*c ? 0 : a-b", filetmp3, filin//"["//str(i)//",*]", filetmp1, filetmp2, ksig, verb-)
	}
        imcopy (filetmp3, filout//"["//str(i)//",*]", ver-) 
	#splot (filetmp3)
	}

	imdelete (filin, ver-, >& "dev$null")
	imdelete (filetmp3, ver-, >& "dev$null")

end
