procedure	omwcal_lines(slity)

real	slity	= 995.0      	{prompt="Slit position in y as in header"}
bool	findcen	= no		{prompt="Find centroid of the line using splot?"}
string  filarc 	= "gtc14a_p1arc_m_HgArNe"   {prompt="Comparison arc file [auto|gtc14a_p1arc_m_HgArNe]"}
int	slitx	= 1		{prompt="X position for splot"}
int	npix	= 2051		{prompt="Number of dispersion pixels"}
string  out	= "omwcal_lines.output"	{prompt="Output file containing the linelist"}
bool	verbose = no		{prompt="Print the coefficients on the terminal"}

begin
	string	id[5], cdate, splotfillog, filin, wcalout, grism, ans
	int	i, il, xx 
	bool	check, print
	real	yx, wlam[5], wpix, cons[5], slop[5], ny, nb

	check = findcen; filin = filarc; wcalout = out; print = verbose
        #hselect (filin, "NAXIS2", expr+) | scan(npix)
        if (check) {
		hselect (filin, "GRISM ", expr+) | scan (grism) 
		} else {
		fields ("MOS_lambda_calib.dat", fields="1", lines="1-")
		print ("Grism name from the above list : ")
		scan(grism)
		}


	yx = slity; xx= slitx; nb = 20.0; ny = real(npix) -nb
        splotfillog = "splot_auto_gaussfit.log"     #used in Block_4
        delete (wcalout, ver-, >& "dev$null")

	if (grism == "R1000B") {
	wlam[1] = 4046.563; wlam[2] = 4358.328; wlam[3] = 5460.735; wlam[4] = 7032.413; wlam[5] = 7635.106
	id[1] = "HgI"; id[2] = "HgI"; id[3] = "HgI"; id[4] = "NeI"; id[5] = "ArI"
	cons[1] = 263.0990; cons[2] = 439.8731; cons[3] = 998.1043; cons[4] = 1696.521; cons[5] = 1950.053
	slop[1] = 1.075242; slop[2] = 1.067655; slop[3] = 0.995629; slop[4] = 0.949008; slop[5] = 0.943467
	}

	if (grism == "R1000R") {
	#wlam[1] = 5460.735; 
	wlam[1] = 5944.834; wlam[2] = 6929.467; wlam[3] = 7032.413; wlam[4] = 8231.635; wlam[5] = 8819.411 #; wlam[2] = 6929.467; wlam[5] = 7245.167; wlam[5] = 8231.635# wlam[4] = 6929.467;
	#cons[1] = 174.86; 
	cons[1] = 391.92; cons[2] = 798.07; cons[3] = 838.51; cons[4] = 1290.38; cons[5] = 1501.74 #; cons[5] = 1501.74; cons[2] = 798.07; cons[4] = 921.17
	id[1] = "HgI"; id[2] = "HgI"; id[3] = "NeI"; id[4] = "XeI"; id[5] = "XeI"
	#wlam[1] = 5460.735; wlam[2] = 5769.598; wlam[3] = 6163.594; wlam[4] = 8280.117; wlam[5] = 8952.252
	#id[1] = "HgI"; id[2] = "HgI"; id[3] = "NeI"; id[4] = "XeI"; id[5] = "XeI"
	#cons[1] = 171.0067; cons[2] = 307.8723; cons[3] = 479.0214; cons[4] = 1305.292; cons[5] = 1547.425
	slop[1] = 1.094978; slop[2] = 1.083335; slop[3] = 1.060465; slop[4] = 0.968345; slop[5] = 0.948483
	}

	il = 0
        for (i=1; i <= 5; i = i + 1) {
	if (cons[i] < 1400.0) {slop[i] = 1.000953477 - 0.0001129754*(cons[i]-995.) } else {
				slop[i] = 0.95689520345 - 0.00001345869*(cons[i]-995.)}
	wpix = cons[i] + slop[i]*(yx-995.)
	if ((wpix > nb) && (wpix < ny)) { il = il + 1 }
	}

	print("        units   Angstroms", >> wcalout) 
	print("        features    ", il, >> wcalout) 

        for (i=1; i <= 5; i = i + 1) {
	wpix = cons[i] + slop[i]*(yx-995.)
	if ((wpix > nb) && (wpix < ny)) {
	if (check){
	if (print) {print (i, wlam[i], wpix)}
	omlinefit (filin, xposlit=xx, yposlit=wpix)
        fields (splotfillog, fields="1", lines=4) | scan (wpix)
        if (print) {print ("Enter Return"); scan(ans)}
	}
	#print ("           ",wpix, wlam[i], wlam[i], "  4.0 1 1 ", id[i], >> "omwcal_lines.output")
	print ("           ",wpix, wlam[i], wlam[i], "  4.0 1 1 ", id[i], >> wcalout)
	}
	}

	if (print) {type (wcalout)}

end
