procedure oltilt(filnam)

string  filnam = "gtc5_14a_std444_wl"   {prompt="File Name"}
real    lamcen    =5577.838         {prompt="Lambda of a sky line in Ang"}
int     xstep     =20             {prompt="X step for sampling"}
int     xbeg      =0              {prompt="X begin for sampling"}
int     xend      =0              {prompt="X end for sampling"}

begin
	string	filin, filetra, secj, splotfillog, ctype2, grism #, obsmode
	real	slitlam_sky, slitlam0_sky, slityxc, lamref, dlam,  pixref, slity0
	real	aa, bb, cc, ee, ff, slityx, dyx, xbin, ybin, xcen, ycen
	int	ix1, ix2, j, dj, npix

	dj=xstep; ix1 = xbeg; ix2=xend
        filin = filnam; slitlam_sky = lamcen

        #hselect (filin, "OBSMODE", expr+) | scan(obsmode)
        #if (obsmode != "OsirisLongSlitSpectroscopy"){
        #print(" *** Data not taken in LongSlit mode, exiting ...Mode=", obsmode)
        #stop
        #}

	filetra = filin//"_tlt"
        splotfillog = "splot_auto_gaussfit.log"     #used in Block_4
	if (ix1 < 160){ix1 = 160}
        hselect (filin, "NAXIS2", expr+) | scan(npix)
	if (ix2 == 0 || ix2 > (npix - 30) ) {ix2 = npix - 30}

	print (ix1, ix2)

	slity0 = slitlam_sky  #5577.00

	imdelete (filetra, ver-, >& "dev$null")
        imarith (filin, "*", 0.0, filetra, ver-)

        hselect (filin, "CCDSUM GRISM", expr+) | fields (fields="1-2") | scan (xbin, ybin, grism)
        xcen=1040.0*2.0/xbin; ycen=995.0*2.0/ybin

        hselect (filin, "CTYPE2", expr+) | scan(ctype2)
	if (ctype2 == "LINEAR"){
        hselect (filin, "CRPIX2 CRVAL2 CDELT2", expr+) | scan(pixref, lamref, dlam)
	}

	type ("gtcinputs$MOS_lambda_calib.dat") | grep R1000B | fields (fields="5-9") | scan (aa,bb,cc,ee,ff)
        #cat "MOS_lambda_calib.dat" | grep R1000B | fields (fields="5-9") | scan (aa,bb,cc,ee,ff)


        #for (j = ix1; j <= ix2; j = j + 2) {
        for (j = ix1; j <= ix2; j = j + dj) {
        #for (j = 800; j <= 900; j = j + dj) {
	if (j > 1040 && j < 1090) { j = 1090}
        dyx = -ee*abs(real(j)-xcen) -ff*(real(j)-xcen)
        slityx = slitlam_sky + dyx
        imdelete (filin//"_tmp", ver-, >& "dev$null")
        secj = "["//str(j)//":"//str(j+dj-1)//",*]"
        #omlinefit (filin, xposlit=real(j), yposlit=slitlam_sky)
        omlinefit (filin, xposlit=real(j), yposlit=slityx)
        fields (splotfillog, fields="1", lines=4) | scan (slitlam0_sky)
	slityxc = slitlam0_sky
        if (ctype2 == "LINEAR"){
		slityxc = (slitlam0_sky - lamref)/dlam + pixref
		slity0  = (slitlam_sky - lamref)/dlam + pixref
		}
	print (j, secj, slityxc, dlam, slityx, slitlam0_sky, slity0)
        imlintran (filin//secj, filin//"_tmp", xrot=0., yrot=0.0, xmag=1.0, ymag=1.0, yin=slityxc, yout=slity0, boundar="constant", constant=0.0, ver-)
        imcopy (filin//"_tmp", filetra//secj, ver-)

                }   #for end

	print ("Tilt-corrected spectra stored as ",filetra)
end
