procedure	omcombine(filein)

string  filein    = ""                       {prompt="Input File Name(s)"}
string  fileout   = "omcombine"              {prompt="File Name"}
string  imtype    = "obj"                    {prompt="Image type [bias|obj|arc|flat]"}
string  combine   = "median"		     {prompt="Type of combine operation"}
string  reject    = "none"		     {prompt="Type of rejection"}
string  normsec   = "[*,*]"		     {prompt="Image Section to Normalize flat"}
string  logfile   = "omcombine.log"	     {prompt="Type of rejection"}

begin
	string	filin, filout, itype, flatsec
	string	ctype, stype, ztype, rtype, comm1, image1, image2
	real	krms
	int	nfiles

	filin = filein; itype = imtype; flatsec = normsec
	filout = fileout    #"temp1.fits"
	delete ("temp.logfile", ver-, >& "dev$null")
	imdelete (filout, ver-, >& "dev$null")

	imstat (filin, field="image,npix,mean,stddev,min,max,midpt", format+)

	ctype = combine; rtype = reject
	stype = "median"; ztype = "none"
	if (itype == "bias"){stype = "none"; ztype = "median"}
	if (itype == "arc"){stype = "none"; ztype = "none"; ctype="sum"; rtype="none"}

	files (filin) | wc | scan(nfiles)
	if (nfiles == 2 && ctype != "sum") {
		ctype = "cosmicray"
		files (filin) | fields (fields="1", lines="1") | scan(image1)
		files (filin) | fields (fields="1", lines="2") | scan(image2)
	}
	#print(image1, image2) 
	#print(nfiles)

	if (ctype == "cosmicray") {
	krms = 1000.0
	#comm1 = "abs(a-b) < "//str(krms)//" ? (a+b)/2.0 : min(a,b)"
	comm1 = "abs(a-b) < 5.*sqrt(abs(min(a,b))) ? (a+b)/2.0 : min(a,b)"
	#print(comm1)
	#imexpr.a = image1; imexpr.b = image2
	imexpr(comm1, filout, image1, image2, verb-)
	} else {
	imcombine (filin, filout, combine=ctype, reject=rtype, scale=stype, zero=ztype, logfile="temp.logfile")
	type ("temp.logfile")
	type ("temp.logfile", >> logfile)
	}
	if (itype == "flat") {normalize (filout, sample_secti=flatsec)}
	print ("Output is stored in ", fileout)
end
