procedure omflat(infile)

string  infile = "gtc14aob4_object_sum_wl_tlt"      {prompt="Input 2D file template"}
string  outfile = "DEFAULT"    	   {prompt="Output Master flat"}
string  flatcor = "slitlet"   	   {prompt="Flat correction method [slitlet/longslit]"}
string  illcorr = "none"   	   {prompt="Illumination correction method [none, illum, slitlet]"}
int     xwin    = "3"              {prompt="X window size of median filter"}
int     ywin    = "3"              {prompt="Y window size of median filter"}
string	medbound= "nearest"	   {prompt="Boundary (constant,nearest,reflect,wrap) for median"}
bool	illinte = no		   {prompt="Enter illumin interactively?"}
string  illfunc = "spline3"	   {prompt="Fitting function in Illumination"}
int	illorde = 11	   	   {prompt="Fitting function order in Illumination"}
int	illnbin = 5   	   	   {prompt="Number of fitting bins in Illumination"}
bool    del     = yes              {prompt="Delete all intermediate files?"}

begin
	string  filin, filen, outnam, filinp, function, sec[999], stype, s1, s2
	string	boundary, statsec[999], illtype, fcor
        real    slitx, slity, slityx, slito, flatnor, flat[999]
	int     xw, yw, i1, i2, order, nbin, nmode
        int     nslits, ix1, ix2, islit, nslice, is, is1, is2, isl
        bool    slice[999], delete, cor_ill, inter

        filinp = infile; xw = xwin; yw = ywin; outnam = outfile; delete = del
	nbin = illnbin; order = illorde; function = illfunc
	illtype = illcorr; inter = illinte; boundary = medbound
	fcor = flatcor

	if (substr(fcor, 1, 1) == "l"){fcor= "longslit"} else {fcor= "slitlet"}
	if (substr(illtype, 1, 1) == "n"){illtype = "none"} 
        else if (substr(illtype, 1, 1) == "i"){illtype = "illum"} else {illtype = "slitlet"}
	#print(fcor, " ",illtype)

	i2 = strstr(".",filinp)
	if (i2 > 0) {i2 = i2 -1} else {i2 = strlen(filinp)}
        i1 = strstr("[",filinp)
	if (i1 == 0){filin = substr(filinp, 1, i2)}
        if (i1 > 0) {i2 = strstr("]",filinp); filin = substr(filinp, 1, i1-1)}

	if (strupr(outnam) == "DEFAULT") {outnam = filin//"_norm"}
    	imdelete (outnam, veri=no,  >& "dev$null")

        omslits (filin, verb-)
        nslits = omslits.nslitlets
        list = omslits.out
	nmode = omslits.obsmod

	#if (nmode == 1 && illtype != "none"){illtype = "slitlet"}
	#print(nmode, " ",illtype)
	#if (nmode > 1 && illtype != "slitlet") {
	if (fcor == "longslit") {
    	imdelete (filin//"_med", veri=no, >& "dev$null")
    	imdelete (filin//"_nor", veri=no,  >& "dev$null")

        #--------------------------------------------------------
	#print ("Step 1: Running a median filter to the image")
        #--------------------------------------------------------

	median (filin, filin//"_med", xw=xw, yw=yw, boundar=boundary, verb-)

        #--------------------------------------------------------
	#print ("Step 2: Normalization --- original/median ")
        #--------------------------------------------------------

	imarith (filin, "/", filin//"_med", filin//"_nor", verb=no)

        #--------------------------------------------------------
	#print ("Step 3: Illumination correction")
        #--------------------------------------------------------
        if (illtype == "illum") {
    	imdelete (filin//"_ill", veri=no,  >& "dev$null")
	illum (filin//"_med", filin//"_ill", functio=function, order=order, interac=inter, bins=" ", nbins=nbin)
        #--------------------------------------------------------
	#print ("Step 4: Master Flat = FlatNorm*FlatIllum")
        #--------------------------------------------------------

    	imdelete (filin//"_flt", veri=no,  >& "dev$null")
	imarith (filin//"_nor", "*", filin//"_ill", filin//"_flt", verb=no)
        imcopy (filin//"_flt", outnam, ver-)
	} else {imcopy (filin//"_nor", outnam, ver-)}
	if (delete) {
    	imdelete (filin//"_med", veri=no, >& "dev$null")
    	imdelete (filin//"_nor", veri=no,  >& "dev$null")
    	imdelete (filin//"_ill", veri=no,  >& "dev$null")
    	imdelete (filin//"_flt", veri=no,  >& "dev$null")
	}
	}

	if (fcor == "slitlet") {
	imexpr ("a*0", outnam, filinp, verb-)
        i1 = 0
        for (i = 1; i <= nslits; i = i + 1) {
        i1 = fscan(list, islit, ix1, ix2, slitx, slity, slityx, stype, slito)
        if (stype != "circular") {
        sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"
        imdelete (filin//"_"//str(i), ver-, >& "dev$null")
        imcopy (filin//sec[i], filin//"_"//str(i), ver-)

	filen = filin//"_"//str(i)
    	imdelete (filen//"_med", veri=no, >& "dev$null")
    	imdelete (filen//"_nor", veri=no,  >& "dev$null")
    	imdelete (filen//"_flt", veri=no,  >& "dev$null")

        #--------------------------------------------------------
	#print ("Step 1: Running a median filter to the image")
        #--------------------------------------------------------

	median (filen, filen//"_med", xw=xw, yw=yw, boundar=boundary, verb-)

        #--------------------------------------------------------
	#print ("Step 2: Normalization --- original/median ")
        #--------------------------------------------------------

	imarith (filen, "/", filen//"_med", filen//"_nor", verb=no)

        if (illtype == "slitlet") {
        #--------------------------------------------------------
	#print ("Step 3: Illumination correction")
        #--------------------------------------------------------
	statsec[i] = "["//str(ix1)//":"//str(ix2)//","//str(int(slityx-20.0))//":"//str(int(slityx+20.0))//"]"
        imstat (filin//statsec[i], fields="midpt", format-) | scan (flat[i])
        flatnor = flat[i]/flat[1]
	print(filin//statsec[i], flat[i], flatnor, slityx, >> "temp1.dat")
	#illum (filen//"_med", filen//"_ill", functio=function, order=order, interac=inter, bins=" ", nbins=nbin)
	#print ("Step 4: Master Flat = FlatNorm*FlatIllum")
	#imarith (filen//"_nor", "*", filen//"_ill", filen//"_flt", verb=no)
	imarith (filen//"_nor", "*", flatnor, filen//"_flt", verb=no)
        imcopy (filen//"_flt", outnam//sec[i], ver-)
	} else {imcopy (filen//"_nor", outnam//sec[i], ver-)}

	if (delete) {
    	imdelete (filen//"_med", veri=no, >& "dev$null")
    	imdelete (filen//"_nor", veri=no,  >& "dev$null")
    	imdelete (filen//"_ill", veri=no,  >& "dev$null")
    	imdelete (filen//"_flt", veri=no,  >& "dev$null")
	}
        imdelete (filin//"_"//str(i), ver-, >& "dev$null")
        }   #!= "circular"
        }   #i = 1; i <= nslits
	}
	if (illtype == "none") {print (" Normalized flat stored in ", outnam)} 
	else {print (" Normalized and illumination corrected flat stored in ", outnam)}
	#print (" *** Done *** ")
	hedit (outnam, "OMFLAT", "yes", add+, ver-, show-)
	hedit (outnam, "FLATCOR", fcor, add+, ver-, show-)
	hedit (outnam, "ILLCOR", illtype, add+, ver-, show-)

end

