procedure       omlam_to_pix(slity, slitx)

real    slity   = 995.0         {prompt="Slit position in y as in header"}
int     slitx   = 1             {prompt="X position for splot"}
int     npix    = 2051          {prompt="Number of dispersion pixels"}
bool    findcen = no            {prompt="Find centroid of the line using splot?"}
string  filarc  = ""   		{prompt="Comparison arc file [auto|gtc14a_p1arc_m_HgArNe]"}
string  graphics="stdgraph"     {prompt="Output graphics device"}
string  out     = "omlam_to_pix.output" {prompt="Output file containing the linelist"}
bool    verbose = no            {prompt="Print the coefficients on the terminal"}
#string	lamcal  = "GTC"		{prompt="Lambda Calibration coefficient datafile"}
#string	lamcal  = "gtcinputs$MOS_lambda_calib.dat"	{prompt="Lambda Calibration coefficient datafile"}

begin
	string	id[55], splotfillog, filin, wcalout, grism, ans
        string  easyidlist, longidlist, clines, calfile
        real    aa, bb, cc, ee, ff, dy, yx, ny, nb, wpix, rfac, coef1, coef2 
	real	wlam[55], cons[55], slop[55], disp, pixel_lam
	int	i, il, xx, nlin, wlamx
        bool    check, print
	#struct	list, line

        check = findcen; filin = filarc; wcalout = out; print = verbose

	calfile = "gtcinputs$MOS_lambda_calib.dat"

        if (filin != "") {hselect (filin, "GRISM ", expr+) | scan (grism)}
        if (filin == "" && !check) {
               fields (calfile, fields="1", lines="1-")
               print ("Grism name from the above list : ")
               scan(grism)
               }

        yx = slity; xx= slitx; nb = 20.0; ny = real(npix) -nb
        splotfillog = "splot_auto_gaussfit.log"     #used in Block_4
        delete (wcalout, ver-, >& "dev$null")

        match (grism, calfile) | fields (fields="4-9") | scan (disp,aa,bb,cc,ee,ff)
        #the solution file is evaluated at x=250. Correct it for the reference x=1040.
        dy = -ee*abs(250.-1040.) -ff*(250.-1040.)
	#print(dy)

        easyidlist = grism//"arc_easyid.txt"
        if (!access (easyidlist) ) {easyidlist = "gtcinputs$"//easyidlist}
        #print(easyidlist)
        longidlist = "gtcinputs$idarco"//grism//".txt"
        list = easyidlist

        i = 0
        while (fscan (list, line) != EOF) {
        if (substr(line, 1, 1) != "#") {
        i = i+1
        wlamx = int(line)
        fields (longidlist, fields="2", lines=7) | scan (nlin)
        clines = "8-"//str(7+nlin)
        delete ("templist", ver-, >& "dev$null")
        fields (longidlist, fields="1,3,7", lines=clines) | grep (str(wlamx)) | scan(cons[i], wlam[i], id[i])
        cons[i] = cons[i] - dy
    	pixel_lam = (-bb+sqrt(bb**2 -4.0*(aa-wlam[i])*cc))/(2.0*cc)    
	#print(cons[i], wlam[i], id[i], " ", pixel_lam)
	#cons[i] = pixel_lam
        }
        }

	dy = - ee*abs(xx-1040.) - ff*(xx-1040.)
#  5460       14.04848     5.614936E-4    -2.015416E-5    7.553334E-10       0.1118901      0.01295109
	#dy = 14.04848 + 5.614936E-4*(xx-1040.) -2.015416E-5*(xx-1040.)**2 + 7.553334E-10*(xx-1040.)**3
	#print(dy)

        rfac  = real(substr(grism, 2, strlen(grism)-1))/1000.
	#rfac = 2.12/disp
		#coef1 = 1.000953477; coef2 = -rfac*0.0001129754
		#coef1 = 1.001778; coef2 = rfac*-9.874151E-5
		coef1 = 1.001778; coef2 = -9.874151E-5/rfac

        il = 0
	nlin = i
        for (i=1; i <= nlin; i = i + 1) {
		slop[i] = coef1 + coef2*(cons[i]-995.)
		wpix = cons[i] + slop[i]*(yx-995.) + dy
        	if ((wpix > nb) && (wpix < ny)) { il = il + 1 }
		#print(i, cons[i], wlam[i], id[i], coef1, coef2, slop[i])
		}

        print("        units   Angstroms", >> wcalout)
        print("        features    ", il, >> wcalout)

        #print ("           ",wpix, wlam[i], wlam[i], "  4.0 1 1 ", id[i])
        for (i=1; i <= nlin; i = i + 1) {
        wpix = cons[i] + slop[i]*(yx-995.) + dy
        if ((wpix > nb) && (wpix < ny)) {
        if (check){
        if (print) {print (i, wlam[i], wpix)}
        #omlinefit (filin, xposlit=xx, yposlit=wpix, graphics=graphics)
	omspestat(filin, xpos=xx, yposlit=wpix, contflux=0.0, basepix=10.0, graphics=graphics)
        fields (splotfillog, fields="1", lines=4) | scan (wpix)
        if (print) {print ("Enter Return"); scan(ans)}
        }
        print ("           ",wpix, wlam[i], wlam[i], "  4.0 1 1 ", id[i], >> wcalout)
        }
        }

        if (print) {type (wcalout)}

end
