procedure omlongslit(filnam)

string  filnam = "gtc14aob001_stds_av"   {prompt="File Name"}
int     xstep     =20             {prompt="X step for sampling"}
int     xbeg      =0              {prompt="X begin for sampling"}
int     xend      =0              {prompt="X end for sampling"}
int	nslits	  =0              {prompt="Out Number of Slits"}
int	badleft   = 160		  {prompt="Left nodata x-pixels"}
int	badright  = 80		  {prompt="Right no data x-pixels"}

begin
	string	filin, stype, grism #, obsmode
	real	slity0, angle, dy250, slityx, dyx, slitx
	real	aa, bb, cc, ee, ff, xbin, ybin, xcen, ycen
	int	ix1, ix2, j, dj, npix, ix_beg, ix_end
	int	islit, x1_bad, x2_bad 

	dj=xstep; ix_beg = xbeg; ix_end=xend
        filin = filnam 
	x1_bad = badleft; x2_bad = badright
        delete (filin//"_head.dat", ver-, >& "dev$null")

        #hselect (filin, "OBSMODE", expr+) | scan(obsmode)
        #if (obsmode != "OsirisLongSlitSpectroscopy"){
        #print(" *** Data not taken in LongSlit mode, exiting ...Mode=", obsmode)
        #stop
        #}

	if (ix_beg < x1_bad){ix_beg = x1_bad}
        #hselect (filin, "NAXIS2 CRPIX2", expr+) | scan(npix, slity0)
        hselect (filin, "NAXIS1 CRPIX2", expr+) | scan(npix, slity0)
	if (ix_end == 0 || ix_end > (npix - x2_bad) ) {ix_end = npix - x2_bad}

	#print (npix, ix_beg, ix_end, slity0)

        hselect (filin, "CCDSUM GRISM", expr+) | fields (fields="1-2") | scan (xbin, ybin, grism)
        xcen=1040.0*2.0/xbin; ycen=995.0*2.0/ybin

        #match (grism, "gtcinputs$MOS_lambda_calib.dat")
        match (grism, "gtcinputs$MOS_lambda_calib.dat") | fields (fields="5-9") | scan (aa,bb,cc,ee,ff)

        #the solution file is evaluated at x=250. Correct it for the reference x=1040.
        dy250 = -ee*abs(250.-1040.) -ff*(250.-1040.)
	#print(dy)

	islit = 0
	#angle = 0.0
        for (j = ix_beg; j <= ix_end; j = j + dj) {
	if (j > 1035 && j < 1090) { j = 1090}
	islit = islit + 1
	ix1 = j; ix2 = ix1 + dj - 1
	if (ix1 > 1035 && j < 1090) {ix1 = 1090}
	if (ix2 > 1040 && j < 1090) {ix2 = 1040}
	if (ix2 > ix_end) {ix2 = ix_end}
        if (ix2 > ix_end - 5) {ix2 = ix_end; j = ix_end + 1}
        slitx = nint(ix1+(ix2-ix1)/2.0)
        dyx = -ee*abs(slitx-xcen) -ff*(slitx-xcen)
        slityx = slity0 + dyx - dy250
	stype = "rectangular  0.0"
        #print (islit, ix1, ix2, slitx, slity0, slityx, stype)
        print (islit, ix1, ix2, slitx, slity0, slityx, stype, >> filin//"_head.dat")
        }   #for end
	nslits = islit

	#print ("nslits ", nslits)
end
