procedure omnormalize(filein, filesky, fileout)

#omnormalize - For an input slitlet spectrum and an 1D sky spectrum, prepare a 2D
#spectrum shifting in lambda and normalizing the fluxes of a skyline.

string	filein = "gtc14aob4_object_sum_wl_tlt[136:184,*]"	{prompt="Input 2D file template"}
string	filesky= "gtc14aob4_object_sum_wl_tlt_1d"		{prompt="Input 1D Sky filename"}
string	fileout= "gtc14aob4_object_sum_wl_tlt_2d"		{prompt="Output normalized 2D Sky filename"}
real    lamsky = 5577.838         				{prompt="Lambda of a sky line in Ang [5577.838, 6300.304]"}
string	normtyp= "flux"						{prompt="Normalize type[flux/core]?"}
bool	shiftw = no						{prompt="Shift lambda also?"}
bool	verbose= no						{prompt="Print output?"}

begin
	string	filin, filout, filsky, normalize, filinp, sec 
	real	slitlam_sky, normfact, slitlam0_sky, cont, flux, eqw, core, gfwhm, lfwhm, flux0, core0
	real	pixini, lamini, dw, skylam0, skypixy0, slitpixy, lamref_corr, laminisky, skylam00
	int	i, dsky, i1, i2
	bool	shiftlam, write

	filinp = filein; filsky = filesky; filout = fileout; slitlam_sky = lamsky; write=verbose
	i1 = strstr("[",filinp)
	if (i1 > 0) {i2 = strstr("]",filinp)}
	filin = substr(filinp, 1, i1-1)//"_tmp"; sec = substr(filinp, i1, i2)
	#print(filin, " ", sec)
	imdelete (filin, ver-, >& "dev$null")
	imcopy (filinp, filin, ver-)
	normalize = strlwr(normtyp); shiftlam = shiftw
        #hselect (filsky, "NAXIS1 CRPIX2 CRVAL2 CDELT2", expr+) | scan(dsky, pixini, laminisky, dw)
        hselect (filsky, "NAXIS1 CRPIX1 CRVAL1 CDELT1", expr+) | scan(dsky, pixini, laminisky, dw)
        hselect (filin, "NAXIS1 CRPIX2 CRVAL2 CDELT2", expr+) | scan(dsky, pixini, lamini, dw)

	imdelete (filout, ver-, >& "dev$null"); imexpr ("a*0", filout, filin, verb-); 

	#set stdvdm="splot.mc"
        omlinefit (filsky, xposlit=1, yposlit=slitlam_sky)
        fields (omlinefit.logfile, fields="1-7", lines=4) | scan (skylam0, cont, flux0, eqw, core0, gfwhm, lfwhm)
	skylam00 = skylam0
        skypixy0 = (skylam0 - lamini)/dw + pixini
	#print(skylam0, skypixy0, laminisky, flux0)

        for (i = 1; i <= dsky; i = i + 1) { 
        omlinefit (filin, xposlit=i, yposlit=slitlam_sky)
        #fields (omlinefit.logfile, fields="1", lines=4) | scan (slitlam0_sky)
        fields (omlinefit.logfile, fields="1-7", lines=4) | scan (slitlam0_sky, cont, flux, eqw, core, gfwhm, lfwhm)
        slitpixy = (slitlam0_sky - lamini)/dw + pixini
        #print(slityxc, slitlam0_sky, slity0)
	imdelete (filsky//"_"//str(i), ver-, >& "dev$null")
	if (shiftlam) {
	#imcopy (filsky, filsky//"_"//str(i), ver-)
	scopy (filsky, filsky//"_"//str(i), ver-)
	lamref_corr = laminisky + (slitlam0_sky - skylam00)
	#lamref_corr = laminisky + (skylam0 - slitlam0_sky)
	hedit (filsky//"_"//str(i), "CRVAL2", lamref_corr, add+, ver-, show-)
        #omlinefit (filsky//"_"//str(i), xposlit=1, yposlit=slitlam_sky)
        #fields (omlinefit.logfile, fields="1-7", lines=4) | scan (skylam0, cont, flux0, eqw, core0, gfwhm, lfwhm)
        #imlintran (filsky, filsky//"_"//str(i), xrot=0., yrot=0.0, xmag=1.0, ymag=1.0, yin=skypixy0, yout=slitpixy, boundar="constant", constant=0.0, nxblock=1, ver-)
	} else {scopy (filsky, filsky//"_"//str(i), ver-)}
	if (normalize == "flux"){normfact = flux/flux0} else {normfact = core/core0}
	if (write) {print(i, flux, flux0, normfact, slitlam0_sky, skylam00)}
	sarith (filsky//"_"//str(i), "*", normfact, filsky//"_n"//str(i), verb-)
	imcopy (filsky//"_n"//str(i), filout//"["//str(i)//",*]", ver-)
	imdelete (filsky//"_"//str(i), ver-, >& "dev$null")
	imdelete (filsky//"_n"//str(i), ver-, >& "dev$null")
	}

end
