procedure omslits(filnam)

string  filnam    = "gtc14a_p1arc_m_HgArNe"   {prompt="File Name"}
bool	verbose   = yes		{prompt="Print the data for each slitlet"}
bool	readhead  = yes		{prompt="Read the header of filnam? [no means uses header from out]"}
int	nslitlets = ""		{prompt="Number of slitlets"}
string  out       = ""          {prompt="Output Text File containing slitlet data"}
string  outreg    = ""          {prompt="Output ds9 Reg File containing slitlet data"}
string  head      = ""		{prompt="Short header for the out slitlet file"}
int	obsmod    = ""		{prompt="Observing mode [1=MOS 2=Longslit]"}
real	xshift    = 0.0		{prompt="X shift between slit image and slit spectra"}
real	yshift    = 0.0		{prompt="Y shift between slit image and slit spectra"}
real	xymag     = 1.0		{prompt="XY magnification between slit image and slit spectra"}
#int	obsmod   = ""		{prompt="Observing mode [1=MOS 2=Longslit 3=Imaging]"}

#input datafiles: ds9_head.txt, database/idarcoR1000B

begin
	string filin, cutc46, sn, stype, sec[999], comm1, filetra, filelam, secj
	string	splotfillog, grism, fillamp, flatim, statsec[999]
	string	flattra, flatlam, obsmode, datahead, maskname
	real	slitx, slity, slitw, slitl, slito, slitr, xbin, ybin, slityx, dyxj
	real	lamc, lam1, lam2, y5577, slity0, dyx, slityx_5577
	real	xcen, ycen, aa, bb, cc, ee, ff, slityxc, ce[4], lamref_corr
	real	slitlam_sky, slitlam0_sky, pixref, lamref, dlam, dlam1
	real	flatnor, flat[999], nx, ny, x_shi, y_shi, xy_mag
	int	i1, nslits, ix1, ix2, islitx, nmode
	bool	slit_orient, doflat, show_circular, print, read

        filin = filnam; print = verbose; read = readhead

	if (read) {
	hselect (filin, "CCDSUM GRISM", expr+) | fields (fields="1-2") | scan (xbin, ybin, grism)
	hselect (filin, "NAXIS1, NAXIS2", expr+) | scan(nx, ny)
	xbin = nint(2110.*2./real(nx)); ybin = nint(2051.*2./real(ny))
	x_shi = xshift; y_shi = yshift; xy_mag = xymag
	#if (ybin != xbin) {print ("xbin=",xbin," and ybin=",ybin," are not the same. Enter xbin, ybin") 
	#scan(xbin, ybin)
	#}
	#ybin = xbin
	#print (xbin, " ", ybin, " ", grism)

	#xbin = 2.0; ybin = 2.0 #xcen=1051.0*2.0/xbin; ycen=976.0*2.0/ybin
	xcen=1040.0*2.0/xbin; ycen=995.0*2.0/ybin

	datahead = "##   ix1   ix2    x_cen   y_mos    y_CCD   stype  angle"

	delete (filin//"_head.dat", ver-, >& "dev$null")

	nmode = 1; maskname = "GTC"
	hselect (filin, "OBSMODE", expr+) | scan(obsmode)
	if (obsmode != "OsirisMOS"){
	hselect (filin, "MASKNAME", expr+) | scan(maskname)
	maskname = substr(maskname, 1, 3)
	}
	if (maskname == "GTC") {nmode=1; obsmode = "OsirisMOS" } else 
                               {nmode=2; obsmode = "OsirisLongSlitSpectroscopy"}
	print("OBSMODE= ",obsmode, " xbin=",xbin," ybin=",ybin, " NX=",nx," NY=",ny)   
	#, " Continue processing ?" ) #scan(continue)

	if (obsmode == "OsirisLongSlitSpectroscopy"){
	omlongslit (filin)
	nslits = omlongslit.nslits
	} else {

    # Define temporary files
        splotfillog = "splot_auto_gaussfit.log"     #used in Block_4

	#---------------------------------------------------------------------
	#Block_1 - read the slitlet parameters from image header
	#osiris_slits (filin)  #write as a list: [filin]_osiris_slits_sort.dat

	delete ("osiris_header_msx_cutc46.dat", ver-, >& "dev$null")
	delete (filin//"_osiris_slits.dat", ver-, >& "dev$null")
	delete (filin//"_osiris_slits_sort.dat", ver-, >& "dev$null")
	#delete (filin//"_head.dat", ver-, >& "dev$null")
	delete (filin//"_slits.reg", ver-, >& "dev$null")

	copy ("gtcinputs$ds9_head.txt", filin//"_slits.reg")
        match (grism, "gtcinputs$MOS_lambda_calib.dat")
	match (grism, "gtcinputs$MOS_lambda_calib.dat") | fields (fields="5-9") | scan (aa,bb,cc,ee,ff)
	#type ("gtcinputs$MOS_lambda_calib.dat") | grep R1000B | fields (fields="5-9") | scan (aa,bb,cc,ee,ff)
	
	task $cut = "$foreign"
	task $cutc46 = ("$(cut -c4-6 $*)")
	imhead (filin, long+) | grep MSX | cutc46 | cat >> "osiris_header_msx_cutc46.dat"
	wc "osiris_header_msx_cutc46.dat" | scan (nslits)

	if (nslits == 0) {
	print ("*** Error: No slits found. It is possible that the slitlet parameters are missing in the header.")
	print ("  Read the help of omslits for getting around this problem")
	return
	}
	if (print) {print (nslits, " slitlets found in ", filin)}
	if (print) {print (datahead)}
	i1 = 0
	list = "osiris_header_msx_cutc46.dat"
	for (i = 1; i <= nslits; i = i + 1) {
	#for (i = 1; i <= 3; i = i + 1) {
	i1 = fscan(list, sn)
	hselect (filin, "MSTY"//sn//" MSX"//sn//" MSY"//sn//" MSW"//sn//" MSL"//sn//" MSO"//sn//" MSR"//sn, expr+, >> filin//"_osiris_slits.dat")
	}
	sort (filin//"_osiris_slits.dat", column=2, ignore-, numeric+, reverse-, >> filin//"_osiris_slits_sort.dat"
	#---------------------------------------------------------------------
	#Block_2 - Read the filin//"_osiris_slits_sort.dat" and define image section for each slitlet
	#        - Also calculates y-shift (dyx) as a function of objects x-distance from the opt. center
	#---------------------------------------------------------------------

        i1 = 0
        list = filin//"_osiris_slits_sort.dat"
        for (i = 1; i <= nslits; i = i + 1) {
	#for (i = 1; i <= 1; i = i + 1) {
	slitr =123.8681
	fields (filin//"_osiris_slits_sort.dat", 1, lines=i) | scan (stype)
	fields (filin//"_osiris_slits_sort.dat", 3, lines=i) | scan (slity)
	if (stype == "rectangular") {
	i1 = fscan(list, stype, slitx, slity, slitw, slitl, slito)
	slitx = slitx/xbin + x_shi; slity=slity/ybin + y_shi; slitl=xy_mag*slitl/xbin; slitw=xy_mag*slitw/ybin
	if (i == 1) { slity0 = slity }
	ix1 = int(slitx - slitl/2.0); ix2= nint(slitx + slitl/2.0)    #; len = ix2-ix1+1
	sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"
	dyx = -ee*abs(slitx-xcen) -ff*(slitx-xcen)
	#slityx_5577 = slity + 123.0 + dyx  
	slityx = slity + dyx  
	comm1 = "box("//str(slitx)//","//str(slity)//","//str(slitl)//","//str(slitw)//","//str(slito)//") # text={"//str(i)//"}"
	   #slit=rectangular over, doing circular apertures
	} else {
	slitl = 0.0; slitw=0.0; slito = 0.0
	i1 = fscan(list, stype, slitx, slity, slitr)
	#slitx = slitx/xbin; slity=slity/ybin; slitl=slitl/xbin; slitw=slitw/ybin; slitr = slitr/xbin
	slitx = slitx/xbin + x_shi; slity=slity/ybin + y_shi; slitr = xy_mag*slitr/xbin
	#print(i, stype, slitx, slitr)
	ix1 = int(slitx - slitr) ; ix2= nint(slitx + slitr) 
	sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"
	dyx = -ee*abs(slitx-xcen) -ff*(slitx-xcen)
	slityx_5577 = slity + 123.0 + dyx  
	slityx = slity + dyx  
	#slityx = slity+122.- (slitx - 3000.0)/100.
	comm1 = "circle("//str(slitx)//","//str(slity)//","//str(slitr)//") # text={"//str(i)//"}"
	#comm1 = "circle("//str(slitx)//","//str(slityx_5577)//","//str(slitr)//") # text={"//str(i)//"}"
	}
	# Both rectangular and circular if over
	print(comm1, >> filin//"_slits.reg")
	#islitx =  nint(slitx)
	if (print) {print (i, ix1, ix2, slitx, slity, slityx, stype, "  ", slito}
	print (i, ix1, ix2, slitx, slity, slityx, stype, "  ", slito, >> filin//"_head.dat")
	}
	if (print) {print (datahead)}
	}
	#mosend:
	omslits.nslitlets = nslits
	omslits.out = filin//"_head.dat"
	omslits.outreg = filin//"_slits.reg"
	omslits.head = datahead
	omslits.obsmod = nmode 
	delete ("osiris_header_msx_cutc46.dat", ver-, >& "dev$null")
	delete (filin//"_osiris_slits.dat", ver-, >& "dev$null")
	delete (filin//"_osiris_slits_sort.dat", ver-, >& "dev$null")

	if (print && nmode==1) {print ("You man open the pre-image in ds9 and load the slitlets region file ",filin,"_slits.reg")}
	}
end
