procedure	omwcal_lines(slity)

real	slity	= 995.0      	{prompt="Slit position in y as in header"}
bool	findcen	= no		{prompt="Find centroid of the line using splot?"}
string  filarc 	= "gtc14a_p1arc_m_HgArNe"   {prompt="Comparison arc file [auto|gtc14a_p1arc_m_HgArNe]"}
int	slitx	= 1		{prompt="X position for splot"}
int	npix	= 2051		{prompt="Number of dispersion pixels"}
string  graphics="stdgraph"     {prompt="Output graphics device"}
string  out	= "omwcal_lines.output"	{prompt="Output file containing the linelist"}
bool	verbose = no		{prompt="Print the coefficients on the terminal"}

begin
	string	id[55], cdate, splotfillog, filin, wcalout, grism, ans
	string  easyidlist, longidlist, cgrep, clines, ddd
	int	i, il, xx, nlin, wlamx
	bool	check, print
	real	yx, wlam[55], wpix, cons[55], slop[55], ny, nb
	real	rfac, coef1, coef2, coef3, coef4, aa, bb, cc, ee, ff, dy

	check = findcen; filin = filarc; wcalout = out; print = verbose
        #hselect (filin, "NAXIS2", expr+) | scan(npix)
	flpr
	if (filin != "") {hselect (filin, "GRISM ", expr+) | scan (grism)}
        #if (check) {
	#	hselect (filin, "GRISM ", expr+) | scan (grism) 
	#	} else {
	#	fields ("gtcinputs$MOS_lambda_calib.dat", fields="1", lines="1-")
	#	print ("Grism name from the above list : ")
	#	scan(grism)
	#	}
	if (filin == "" && !check) {
               fields ("gtcinputs$MOS_lambda_calib.dat", fields="1", lines="1-")
               print ("Grism name from the above list : ")
               scan(grism)
               }

	yx = slity; xx= slitx; nb = 20.0; ny = real(npix) -nb
        splotfillog = "splot_auto_gaussfit.log"     #used in Block_4
        delete (wcalout, ver-, >& "dev$null")

        match (grism, "gtcinputs$MOS_lambda_calib.dat") | fields (fields="5-9") | scan (aa,bb,cc,ee,ff)
	#the solution file is evaluated at x=250. Correct it for the reference x=1040.
	dy = -ee*abs(250.-1040.) -ff*(250.-1040.)

	easyidlist = grism//"arc_easyid.txt"
	if (!access (easyidlist) ) {easyidlist = "gtcinputs$"//easyidlist}
	#print(easyidlist)
	longidlist = "gtcinputs$idarco"//grism//".txt"
	list = easyidlist

	i = 0
	while (fscan (list, line) != EOF) {
	if (substr(line, 1, 1) != "#") {
	i = i+1
	wlamx = int(line)
	#task $grep = "grep $1 $(2)"

        fields (longidlist, fields="2", lines=7) | scan (nlin)
	clines = "8-"//str(7+nlin)
	delete ("templist", ver-, >& "dev$null")
        fields (longidlist, fields="1,3,7", lines=clines) | grep (str(wlamx)) | scan(cons[i], wlam[i], id[i]) 
        #fields (longidlist, fields="1,3,7", lines=clines) | match(str(wlamx)) | scan(cons[i], wlam[i], id[i]) 
	#print(cons[i], wlam[i], id[i])
	cons[i] = cons[i] - dy
	}
	}

	rfac  = real(substr(grism, 2, strlen(grism)-1))/1000.
	coef1 = 1.000953477; coef2 = rfac*0.0001129754 
	coef3 = coef1 - coef2*(1385.-995.); coef4 = 0.00001345869
	#print (grism, " ", rfac, coef1, coef2, coef3, coef4)
	il = 0
        #for (i=1; i <= 5; i = i + 1) {
        for (i=1; i <= nlin; i = i + 1) {
	#if (cons[i] < 1400.0) {slop[i] = 1.000953477 - 0.0001129754*(cons[i]-995.) } else {
	#			slop[i] = 0.95689520345 - 0.00001345869*(cons[i]-995.)}
	if (cons[i] < 1400.0) {slop[i] = coef1 - coef2*(cons[i]-995.) } else {
			       slop[i] = coef3 - coef4*(cons[i]-995.)}
	wpix = cons[i] + slop[i]*(yx-995.)
	if ((wpix > nb) && (wpix < ny)) { il = il + 1 }
	}

	print("        units   Angstroms", >> wcalout) 
	print("        features    ", il, >> wcalout) 

        #for (i=1; i <= 5; i = i + 1) {
        for (i=1; i <= nlin; i = i + 1) {
	wpix = cons[i] + slop[i]*(yx-995.)
	if ((wpix > nb) && (wpix < ny)) {
	if (check){
	if (print) {print (i, wlam[i], wpix)}
	omlinefit (filin, xposlit=xx, yposlit=wpix, graphics=graphics)
        fields (splotfillog, fields="1", lines=4) | scan (wpix)
        if (print) {print ("Enter Return"); scan(ans)}
	}
	#print ("           ",wpix, wlam[i], wlam[i], "  4.0 1 1 ", id[i], >> "omwcal_lines.output")
	print ("           ",wpix, wlam[i], wlam[i], "  4.0 1 1 ", id[i], >> wcalout)
	}
	}

	if (print) {type (wcalout)}

end
